/* Percepts provided by the world are as follows:
 *   gsize(N,X,Y) - the current grid is scenario N, dimensions X by Y (cells 0 to (X-1))
 *   depot(N,X,Y) - Grid scenario N, and the gold depot is at X,Y 
 *   pos(X,Y) - the agent's current position
 *   carrying_gold - this belief will be held if the agent has picked up gold.
 *   cell(X,Y,Object) - if there's an object in any of the 8 adjacent cells, then 
	    				these beliefs will hold. Object can be "obstacle", "gold", or "ally".
		    			Note ally will also appear for the current agent, at its position

 * Actions availible are of the form do(Action) where Action is:
 *   up - to move up (Y-1 - note 0,0 is the top left of the grid)
 *   down - to move down (Y+1)
 *   right - to move right (X+1)
 *   left - to move left (X-1)
 *   pick - to pick up some gold, only 1 piece can be carried at one time.
 *   drop - to drop some gold.
 */

/* This is the initial goal.*/

!go(16, 4).

/* Getting gold */

// TODO
	
/* go routine - robot is going to position (X, Y) */

+!goTo(X, Y) : true // go to the point (X, Y)
	<- +goTo(X, Y); // remember the destination
	!go(X, Y).

+!go(X, Y) : pos(X, Y) // we are at the destination.
	<- -goTo(X, Y). // delete the destination from our beliefs
	//.print("Successfully arrived at (", X, ", ", Y, ")."). 

// move left 
+!go(X, Y) : pos(Xc, Yc) & (Xc > X)
	<- //!move(left);
	!move(left);
	!go(X, Y).
	
// move right 
+!go(X, Y) : pos(Xc, Yc) & (Xc < X) 
	<- //!move(right);
	!move(right);
	!go(X, Y).

// move up
+!go(X, Y) : pos(Xc, Yc) & (Yc > Y)
	<- //!move(up);
	!move(up);
	!go(X,Y).
	
// move down
+!go(X, Y) : pos(Xc, Yc) & (Yc < Y)
	<- //!move(down);
	!move(down);
	!go(X, Y).
	
+!go(X, Y) : pos(Xc, Yc) // error case
	<- .println("ERROR! Trying to go: ", X, Y, " from: ", Xc, Yc).	

/* randomized collision */

// TODO
	
/* no collision avoidance */

+!move(Dir) : true
	<- do(Dir).

